/* ************************** */
/* DELIMITER = dtDefault      */
/* ************************** */

CREATE GENERATOR CUST_NO_GEN;
CREATE GENERATOR EMP_NO_GEN;

CREATE DOMAIN ADDRESSLINE
 AS Varchar(30) 
 CHARACTER SET UTF8;
CREATE DOMAIN BUDGET
 AS Decimal(12,2)
 DEFAULT 50000
 CHECK (VALUE > 10000 AND VALUE <= 2000000)
;
CREATE DOMAIN COUNTRYNAME
 AS Varchar(15)
 CHARACTER SET UTF8;
CREATE DOMAIN CUSTNO
 AS Integer
 CHECK (VALUE > 1000)
;
CREATE DOMAIN DEPTNO
 AS Char(3) CHARACTER SET UTF8
 CHECK (VALUE = '000' OR (VALUE > '0' AND VALUE <= '999') OR VALUE IS NULL);
CREATE DOMAIN EMPNO
 AS Smallint
;
CREATE DOMAIN FIRSTNAME
 AS Varchar(15)
 CHARACTER SET UTF8;
CREATE DOMAIN JOBCODE
 AS Varchar(5) 
 CHARACTER SET UTF8
 CHECK (VALUE > '99999')
;
CREATE DOMAIN JOBGRADE
 AS Smallint
 CHECK (VALUE BETWEEN 0 AND 6)
;
CREATE DOMAIN LASTNAME
 AS Varchar(20)
 CHARACTER SET UTF8;
CREATE DOMAIN PHONENUMBER
 AS Varchar(20)
 CHARACTER SET UTF8;
CREATE DOMAIN PONUMBER
 AS Char(8) CHARACTER SET UTF8
 CHECK (VALUE STARTING WITH 'V')
;
CREATE DOMAIN PRODTYPE
 AS Varchar(12) CHARACTER SET UTF8
 DEFAULT 'software'
 NOT NULL
 CHECK (VALUE IN ('software', 'hardware', 'other', 'N/A'))
;
CREATE DOMAIN PROJNO
 AS Char(5) CHARACTER SET UTF8
 CHECK (VALUE = UPPER (VALUE))
;
CREATE DOMAIN SALARY
 AS Numeric(10,2)
 DEFAULT 0
 CHECK (VALUE > 0)
;
