ALTER PROCEDURE ADD_EMP_PROJ (
    EMP_NO Smallint,
    PROJ_ID Char(5) )
AS
BEGIN
 BEGIN
 INSERT INTO employee_project (emp_no, proj_id) VALUES (:emp_no, :proj_id);
 WHEN SQLCODE -530 DO
  EXCEPTION unknown_emp_id;
 END
 SUSPEND;
END



ALTER PROCEDURE ALL_LANGS
RETURNS (
    CODE Varchar(5),
    GRADE Varchar(5),
    COUNTRY Varchar(15),
    LANG Varchar(15) )
AS
BEGIN
 FOR SELECT job_code, job_grade, job_country FROM job
  INTO :code, :grade, :country
 DO
 BEGIN
     FOR SELECT languages FROM show_langs
       (:code, :grade, :country) INTO :lang DO
         SUSPEND;
     code = '=====';
     grade = '=====';
     country = '===============';
     lang = '==============';
     SUSPEND;
 END
 END


 
ALTER PROCEDURE DELETE_EMPLOYEE (
    EMP_NUM Integer )
AS
DECLARE VARIABLE any_sales INTEGER;
BEGIN
 any_sales = 0;
 SELECT count(po_number)
 FROM sales
 WHERE sales_rep = :emp_num
 INTO :any_sales;
 IF (any_sales > 0) THEN
 BEGIN
  EXCEPTION reassign_sales;
  SUSPEND;
 END
 UPDATE department
 SET mngr_no = NULL
 WHERE mngr_no = :emp_num;
 UPDATE project
 SET team_leader = NULL
 WHERE team_leader = :emp_num;
 DELETE FROM employee_project
 WHERE emp_no = :emp_num;
 DELETE FROM salary_history
 WHERE emp_no = :emp_num;
 DELETE FROM employee
 WHERE emp_no = :emp_num;
 SUSPEND;
END



ALTER PROCEDURE DEPT_BUDGET (
    DNO Char(3) )
RETURNS (
    TOT Decimal(12,2) )
AS
DECLARE VARIABLE sumb DECIMAL(12, 2);
 DECLARE VARIABLE rdno CHAR(3);
 DECLARE VARIABLE cnt INTEGER;
BEGIN
 tot = 0;
 SELECT budget FROM department WHERE dept_no = :dno INTO :tot;
 SELECT count(budget) FROM department WHERE head_dept = :dno INTO :cnt;
 IF (cnt = 0) THEN
  SUSPEND;
 FOR SELECT dept_no
  FROM department
  WHERE head_dept = :dno
  INTO :rdno
 DO
  BEGIN
   EXECUTE PROCEDURE dept_budget :rdno RETURNING_VALUES :sumb;
   tot = tot + sumb;
  END
 SUSPEND;
END



ALTER PROCEDURE GET_EMP_PROJ (
    EMP_NO Smallint )
RETURNS (
    PROJ_ID Char(5) )
AS
BEGIN
 FOR SELECT proj_id
  FROM employee_project
  WHERE emp_no = :emp_no
  INTO :proj_id
 DO
  SUSPEND;
END



ALTER PROCEDURE MAIL_LABEL (
    CUST_NO Integer )
RETURNS (
    LINE1 Char(40),
    LINE2 Char(40),
    LINE3 Char(40),
    LINE4 Char(40),
    LINE5 Char(40),
    LINE6 Char(40) )
AS
DECLARE VARIABLE customer VARCHAR(25);
 DECLARE VARIABLE first_name  VARCHAR(15);
 DECLARE VARIABLE last_name  VARCHAR(20);
 DECLARE VARIABLE addr1  VARCHAR(30);
 DECLARE VARIABLE addr2  VARCHAR(30);
 DECLARE VARIABLE city  VARCHAR(25);
 DECLARE VARIABLE state  VARCHAR(15);
 DECLARE VARIABLE country VARCHAR(15);
 DECLARE VARIABLE postcode VARCHAR(12);
 DECLARE VARIABLE cnt  INTEGER;
BEGIN
 line1 = '';
 line2 = '';
 line3 = '';
 line4 = '';
 line5 = '';
 line6 = '';
 SELECT customer, contact_first, contact_last, address_line1,
  address_line2, city, state_province, country, postal_code
 FROM CUSTOMER
 WHERE cust_no = :cust_no
 INTO :customer, :first_name, :last_name, :addr1, :addr2,
  :city, :state, :country, :postcode;
 IF (customer IS NOT NULL) THEN
  line1 = customer;
 IF (first_name IS NOT NULL) THEN
  line2 = first_name || ' ' || last_name;
 ELSE
  line2 = last_name;
 IF (addr1 IS NOT NULL) THEN
  line3 = addr1;
 IF (addr2 IS NOT NULL) THEN
  line4 = addr2;
 IF (country = 'USA') THEN
 BEGIN
  IF (city IS NOT NULL) THEN
   line5 = city || ', ' || state || '  ' || postcode;
  ELSE
   line5 = state || '  ' || postcode;
 END
 ELSE
 BEGIN
  IF (city IS NOT NULL) THEN
   line5 = city || ', ' || state;
  ELSE
   line5 = state;
  line6 = country || '    ' || postcode;
 END
 SUSPEND;
END



ALTER PROCEDURE ORG_CHART
RETURNS (
    HEAD_DEPT Char(25),
    DEPARTMENT Char(25),
    MNGR_NAME Char(20),
    TITLE Char(5),
    EMP_CNT Integer )
AS
DECLARE VARIABLE mngr_no INTEGER;
 DECLARE VARIABLE dno CHAR(3);
BEGIN
 FOR SELECT h.department, d.department, d.mngr_no, d.dept_no
  FROM department d
  LEFT OUTER JOIN department h ON d.head_dept = h.dept_no
  ORDER BY d.dept_no
  INTO :head_dept, :department, :mngr_no, :dno
 DO
 BEGIN
  IF (:mngr_no IS NULL) THEN
  BEGIN
   mngr_name = '--TBH--';
   title = '';
  END
  ELSE
   SELECT full_name, job_code
   FROM employee
   WHERE emp_no = :mngr_no
   INTO :mngr_name, :title;
  SELECT COUNT(emp_no)
  FROM employee
  WHERE dept_no = :dno
  INTO :emp_cnt;
  SUSPEND;
 END
END



ALTER PROCEDURE SHIP_ORDER (
    PO_NUM Char(8) )
AS
DECLARE VARIABLE ord_stat CHAR(7);
 DECLARE VARIABLE hold_stat CHAR(1);
 DECLARE VARIABLE cust_no INTEGER;
 DECLARE VARIABLE any_po CHAR(8);
BEGIN
 SELECT s.order_status, c.on_hold, c.cust_no
 FROM sales s, customer c
 WHERE po_number = :po_num
 AND s.cust_no = c.cust_no
 INTO :ord_stat, :hold_stat, :cust_no;
 IF (ord_stat = 'shipped') THEN
 BEGIN
  EXCEPTION order_already_shipped;
  SUSPEND;
 END
 ELSE IF (hold_stat = '*') THEN
 BEGIN
  EXCEPTION customer_on_hold;
  SUSPEND;
 END
 FOR SELECT po_number
  FROM sales
  WHERE cust_no = :cust_no
  AND order_status = 'shipped'
  AND paid = 'n'
  AND ship_date < CAST('NOW' AS TIMESTAMP) - 60
  INTO :any_po
 DO
 BEGIN
  EXCEPTION customer_check;
  UPDATE customer
  SET on_hold = '*'
  WHERE cust_no = :cust_no;
  SUSPEND;
 END
 UPDATE sales
 SET order_status = 'shipped', ship_date = 'NOW'
 WHERE po_number = :po_num;
 SUSPEND;
END


ALTER PROCEDURE SHOW_LANGS (
    CODE Varchar(5),
    GRADE Smallint,
    CTY Varchar(15) )
RETURNS (
    LANGUAGES Varchar(15) )
AS
DECLARE VARIABLE i INTEGER;
BEGIN
  i = 1;
  WHILE (i <= 5) DO
  BEGIN
    SELECT language_req FROM joB /* SELECT language_req[:i] FROM joB */
    WHERE ((job_code = :code) AND (job_grade = :grade) AND (job_country = :cty)
           AND (language_req IS NOT NULL))
    INTO :languages;
    IF (languages = ' ') THEN
       languages = 'NULL';
    i = i +1;
    SUSPEND;
  END
END



ALTER PROCEDURE SUB_TOT_BUDGET (
    HEAD_DEPT Char(3) )
RETURNS (
    TOT_BUDGET Decimal(12,2),
    AVG_BUDGET Decimal(12,2),
    MIN_BUDGET Decimal(12,2),
    MAX_BUDGET Decimal(12,2) )
AS
BEGIN
 SELECT SUM(budget), AVG(budget), MIN(budget), MAX(budget)
  FROM department
  WHERE head_dept = :head_dept
  INTO :tot_budget, :avg_budget, :min_budget, :max_budget;
 SUSPEND;
END

