unit FormTabellenAnlage;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Buttons,
  EditBtn, LemRoutines, FormZeosAnlage, IDEWindowIntf, RTTICtrls,
  VirtualTrees, SynEdit, SynHighlighterSQL, datamodulezeos,
  ZScriptParser, LCLType, LResources, ExtCtrls;

type

  { TFormTABAnlegenSQL }

  TFormTABAnlegenSQL = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ButtonSCLSCRIPTSpeichen: TButton;
    CHDBCharset: TComboBox;
    CHDelimiter: TComboBox;
    DEDBSetpath: TDirectoryEdit;
    EditDelimeterText: TEdit;
    EditSemikolon: TEdit;
    EdtDatabaseName: TEdit;
    EdtDatabaseZusatz: TEdit;
    EdtDBPassword: TEdit;
    EdtDBUsername: TEdit;
    LabelFile: TLabel;
    LblDBCharSet: TLabel;
    LblDBName: TLabel;
    LblDBName2: TLabel;
    LblDBName3: TLabel;
    LblDBPassword: TLabel;
    LblFDBType: TLabel;
    LblSetStorageLocation: TLabel;
    OpenDialogLoadSQL: TOpenDialog;
    PanelFile: TPanel;
    PanelMiddle: TPanel;
    PanelTop: TPanel;
    PanelBottom: TPanel;
    SaveDialogLoadSQL: TSaveDialog;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    SynEdit1: TSynEdit;
    SynSQLSyn1: TSynSQLSyn;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ButtonSCLSCRIPTSpeichenClick(Sender: TObject);
    procedure CHDelimiterChange(Sender: TObject);
    procedure EditSemikolonChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);


  private

  public

  end;

var
  FormTABAnlegenSQL: TFormTABAnlegenSQL;


{ **************************************************************************** }
{ *                              IMPLEMTATION                                * }
{ **************************************************************************** }
implementation

{$R *.lfm}


{ ================================================================== }
{ FORM CREATE                                                        }
{ ================================================================== }
procedure TFormTABAnlegenSQL.FormCreate(Sender: TObject);

var section, key, dbname: string;
                       s: string;
                  Chrset: string;

begin
  // weiß nicht, ob der Delimeter gebraucht wird
  s:= dmZeosFirebird.ZSQLProcessorFirebird.Delimiter;
  EditSemikolon.Text:= s;

  { ; Delimiter soll vorerst nur angezeigt werden                 }
  // CHDelimiter.ReadOnly:= true;

  { Zuletzt angelegte Datenbank wieder anzeigen, von INI lesen }
  { Sektion ist Bezeichnung der Form }
  section:= FormFBAnlegen.Name;

  // Datenbankpfad
  key:= 'LOCATION';
  DEDBSetpath.Text:= GlobIniRead(section, key);

  // Datenbankbezeichnung
  key:= 'DATABASE';
  EdtDatabaseName.Text:= GlobIniRead(section, key);

  // Dateiübersicht die richtige Location angeben
  // User
  key:= 'USER';
  EdtDBUsername.Text:= GlobIniRead(section, key);

  // Passwort
  key:= 'PASSWORT';
  EdtDBPassword.Text:= GlobIniRead(section, key);

  // Zeichensatz
  key:= 'ZEICHENSATZ';
  CHDBCharset.Text:= GlobIniRead(section, key);

  { Pfad und Dateinamen zusammenstellen }
  dbname:= DEDBSetpath.Text;
  dbname:= dbname+ '\'+ EdtDatabaseName.Text+'.FDB';

  { Alle Werte an die ZConnection übergeben                     }
  with dmZeosFirebird.ZConnectionFirebird do begin

     {  Properties sicherheitshalber leeren                       }
     Properties.Clear;

     { Welche Datenbank verwendet wird, hier firebird in einer    }
     { globalen Variable }
     Protocol := DBProtocol;

     { User und Passwort übernehmen }
     Database:= dbname;
     User := EdtDBUsername.Text;
     Password := EdtDBPassword.Text;

     { der Charakterset der Datenbank, vorzugsweise UTF8            }
     Chrset:= CHDBCharset.Text;

     { Speicherort von fbclient.dll                                 }
     { muss noch parametrisiert werden                              }{ TODO : Muss noch parametrisiert werden }
     LibraryLocation:= 'C:\ZEOS_FIREBIRD_TUTOR1\fb464\fbclient.dll';
  end;
end;


{ ================================================================== }
{ FORM WIRD GESCHLOSSEN                                              }
{ ================================================================== }
procedure TFormTABAnlegenSQL.FormDestroy(Sender: TObject);

begin
  { Datenbank schließen                                              }
  dmZeosFirebird.ZConnectionFirebird.Disconnect;
end;

{ ================================================================== }
{ DELIMITER kann zum Anlegen von Procedures etc. geändert werden     }
{ ================================================================== }
procedure TFormTABAnlegenSQL.CHDelimiterChange(Sender: TObject);

var        i: integer;
    delmodus: string;

begin
  { den geänderten Delimiter an ZSQLProcesssor zurückgeben           }
  i:= CHDelimiter.ItemIndex;
  dmZeosFirebird.ZSQLProcessorFirebird.DelimiterType:= TZDelimiterType(i);

  { Anzeige welche SQL-Verarbeitung aufgrund des Delimiters nun möglich ist    }
  case i of
    0: begin
         delModus:= 'SQL ohne Semikolon innerhalb vom Script';
         CHDelimiter.Font.Color:= clGreen;
       end;

    1: begin
         delModus:= 'Nicht deklariert';
         CHDelimiter.Font.Color:= clRed;
       end;

    2: begin
         delModus:= 'Nicht deklariert';
         CHDelimiter.Font.Color:= clRed;
       end;

    3: begin
         delModus:= 'Nicht deklariert';
         CHDelimiter.Font.Color:= clRed;
       end;

    4: begin
         delModus:= 'SQL mit Semikolon innerhalb vom Skript';
         CHDelimiter.Font.Color:= clGreen;
       end;
  end;

  { Farbe ändern und Text anzeigen }
  EditDelimeterText.Font.Color:= CHDelimiter.Font.Color;
  EditDelimeterText.Text:= delModus;
end;

{ ================================================================== }
{ Delinmiter kann geändert werden und wird hier ZSQLPr. übernommen   }
{ ================================================================== }
procedure TFormTABAnlegenSQL.EditSemikolonChange(Sender: TObject);

begin
  dmZeosFirebird.ZSQLProcessorFirebird.Delimiter:= EditSemikolon.Text;
end;

{ ================================================================== }
{ Datenbank mit Hilfe von ZSQLProcessor füllen                       }
{ ================================================================== }
procedure TFormTABAnlegenSQL.Button1Click(Sender: TObject);

begin
  dmZeosFirebird.ZConnectionFirebird.Disconnect;
  dmZeosFirebird.ZConnectionFirebird.Connect;
  dmZeosFirebird.ZSQLProcessorFirebird.Script:= SynEdit1.Lines;
  dmZeosFirebird.ZSQLProcessorFirebird.execute;
  dmZeosFirebird.ZConnectionFirebird.Connected:= false;
  dmZeosFirebird.ZSQLProcessorFirebird.Script.Clear;
end;

{ ================================================================== }
{ Laden des SQL.Scriptes                                             }
{ ================================================================== }
procedure TFormTABAnlegenSQL.Button2Click(Sender: TObject);

var filename : string;

begin
   if OpenDialogLoadSQL.Execute then
   begin
     filename := OpenDialogLoadSQL.Filename;
     SynEdit1.lines.LoadFromFile(filename);
     LabelFile.Caption:= filename;
   end;
end;

procedure TFormTABAnlegenSQL.Button3Click(Sender: TObject);
begin
  Close;
end;

{ ================================================================== }
{ Speichern des SQL-Scriptes                                         }
{ ================================================================== }
procedure TFormTABAnlegenSQL.ButtonSCLSCRIPTSpeichenClick(Sender: TObject);

var filename: string;
           s: string;

begin
   if SaveDialogLoadSQL.Execute then begin
    filename := SaveDialogLoadSQL.Filename;
    if FileExists(filename) then begin
     { Sicherheitsabfrage wegen Überschreiben }
      s:= filename+' Überschreiben';
      if MessageDlg(s, mtConfirmation, [mbYes, mbNo],0)=mrYes then begin
        SynEdit1.lines.SaveToFile(filename);
      end;
    end;
  end;
end;


end.

