unit LemRoutines;

{$mode objfpc}{$H+}

interface

  uses  Classes, SysUtils, IniFiles, Interfaces, Forms;

  { Globale Konstanten }
  // const

  { Globale Variablen }
 var
  { um mögliche spätere Implemtierungen für ander DB zu erleichtern }
  DBProtocol: string;


  { Glonale Parameter gültig für alle Programme }
  procedure SetGlobalParameters;
  { Vereinfachtes lesen von INI-Daten }
  function LemIniRead(var LemIniFile, LemIniSection, LemIniKey: string): string;
  function GlobIniRead(var LemIniSection, LemIniKey: string): string;
  { Vereinfachtes Schreiben von INI-Dateien }
  function LemIniWrite(var LemIniFile, LemIniSection, LemIniKey, LemIniValue: string): string;
  function GlobIniWrite(var LemIniSection, LemIniKey, LemIniValue: string): string;


implementation

procedure SetGlobalParameters;
  Begin
    //
  end;

{ **************************************************************************** }
{ * LEMINIREAD vereinfachtes lesen von INI-Daten                              * }
{ **************************************************************************** }
function LemIniRead(var LemIniFile, LemIniSection, LemIniKey: string): string;

var   List: TiniFile;
    LemVal: String;
        le: Integer;

begin
  List:= TIniFile.Create(LemIniFile+ '.ini');
  LemVal:= List.ReadString(LeminiSection, LemIniKey, '');
  List.Free;
  // le:= Length(LemVal)-2;
  // LemVal:= Copy(LemVal,2,le);
  LemIniRead:= LemVal;
end;

{ **************************************************************************** }
{ * GLOBINIREAD vereinfachtes lesen von INI-Daten ohne Dateinamenparameter   * }
{ **************************************************************************** }
function GlobIniRead(var LemIniSection, LemIniKey: string): string;

var      s: string;


begin
  s:= Application.Title;
  GlobIniRead:= LemIniRead(s,LemIniSection, LemIniKey);
end;

{ **************************************************************************** }
{ * LEMINIWRITE vereinfachtes schreiben von INI-Daten                        * }
{ **************************************************************************** }
function LemIniWrite(var LemIniFile, LemIniSection, LemIniKey, LemIniValue: string): string;

var   List: TiniFile;
    LemVal: String;
begin
  LemVal:= '"'+LemIniValue+'"';
  List := TIniFile.Create(LemIniFile+ '.ini');
  List.WriteString(LemIniSection, LemIniKey, LemVal);
  List.Free;
  LemIniWrite:= LemIniValue;
end;

{ **************************************************************************** }
{ * GLOBINIWRITE vereinfachtes lesen von INI-Daten ohne Dateinamenparameter   * }
{ **************************************************************************** }
function GlobIniWrite(var LemIniSection, LemIniKey, LemIniValue: string): string;

var s: string;

begin
  s:= Application.Title;
  LemIniWrite(s, LemIniSection, LemIniKey, LemIniValue);
  GlobIniWrite:= LemIniValue;
end;

{ **************************************************************************** }
{ *                             INITIALIZATION                               * }
{ **************************************************************************** }
initialization

   // Wert für DBProtocol setzen
   DBProtocol:= 'firebird';

end.

